<?php
    
    namespace common\models;
    
    use yii\base\Model;
    use yii\data\ActiveDataProvider;
    
    /**
     * CategoryToPurposeSearch represents the model behind the search form about `common\models\CategoryToPurpose`.
     */
    class CategoryToPurposeSearch extends CategoryToPurpose
    {
        /**
         * @inheritdoc
         */
        public function rules()
        {
            return [
                [
                    [
                        'category_id',
                        'purpose_id',
                    ],
                    'string',
                ],
            ];
        }
        
        /**
         * @inheritdoc
         */
        public function scenarios()
        {
            // bypass scenarios() implementation in the parent class
            return Model::scenarios();
        }
        
        /**
         * Creates data provider instance with search query applied
         *
         * @param array $params
         *
         * @return ActiveDataProvider
         */
        public function search($params)
        {
            $query = CategoryToPurpose::find()
                                      ->joinWith('category.lang')
                                      ->joinWith('purpose.lang');
            
            // add conditions that should always apply here
            
            $dataProvider = new ActiveDataProvider(
                [
                    'query' => $query,
                ]
            );
            
            $dataProvider->setSort(
                [
                    'attributes' => [
                        'category_id',
                        'purpose_id',
                    ],
                ]
            );
            
            $this->load($params);
            
            if (!$this->validate()) {
                // uncomment the following line if you do not want to return any records when validation fails
                // $query->where('0=1');
                return $dataProvider;
            }
            
            // grid filtering conditions
            
            $query->andFilterWhere(
                [
                    'like',
                    'category_lang.name',
                    $this->category_id,
                ]
            )
                  ->andFilterWhere(
                      [
                          'like',
                          'tax_option_lang.value',
                          $this->purpose_id,
                      ]
                  );
            
            return $dataProvider;
        }
    }
